/**
 * Copyright (c) IBM Japan 2013. All rights reserved.
 */
package net.dependableos.dcase.toolchain.rhapsodyextension.commands;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.UUID;

import javax.swing.JFrame;

import net.dependableos.dcase.toolchain.rhapsodyextension.DCasePlugin;
import net.dependableos.dcase.toolchain.rhapsodyextension.model.DAssumption;
import net.dependableos.dcase.toolchain.rhapsodyextension.model.DCaseDiagram;
import net.dependableos.dcase.toolchain.rhapsodyextension.model.DContext;
import net.dependableos.dcase.toolchain.rhapsodyextension.model.DEdge;
import net.dependableos.dcase.toolchain.rhapsodyextension.model.DInContextOf;
import net.dependableos.dcase.toolchain.rhapsodyextension.model.DJustification;
import net.dependableos.dcase.toolchain.rhapsodyextension.model.DNode;

import com.telelogic.rhapsody.core.*;

/**
 * D-CasefvfSysMLfvf̊֘AtsNX
 */
public class SysML_LinkCreator {

	/** Rhapsody Application */
	protected IRPApplication app = null;
	
	/** Rhapsody Project */
	protected IRPProject prj = null;
	
	/**
	 * RXgN^
	 * @param app Rhapsody Application
	 */
	public SysML_LinkCreator(IRPApplication app) {
		this.app = app;
		this.prj = app.activeProject();
	}
	
	/**
	 * }EXőID-Casefvfɑ΂āAContextȂǂ̑ISysMLfvfǉ
	 * @param menuItem ǉSysMLfvf̎ʁiContextȂǁj
	 */
	public void createLink(String menuItem){
		// SysMLfvf̈ꗗ擾
		IRPModelElement[] models = getModelElements();
		String[] modelNames = new String[models.length];
		for ( int i = 0; i < models.length; i++ ){
			String strIF = models[i].getInterfaceName();
			// I/F̐擪 "IRP" O
			if(strIF.length()>3){
				strIF = strIF.substring(3, strIF.length());
			}
			modelNames[i] = strIF + ",  " + models[i].getName() + ",  " + models[i].getDisplayName();
		}
		
		// SysMLfvf̈ꗗXg\
		String title = "SysMLvfIĂ";
		int xPos = 10;
		int yPos = 10;
		int yOffset = 80;
		int width = SysML_SelectForm.WINDOW_WIDTH + 2 * xPos;
		int height = SysML_SelectForm.WINDOW_HEIGHT + 2 * yPos + yOffset;
		SysML_SelectedItemNotifier notifier = new SysML_SelectedItemNotifier();
		SysML_SelectForm form = new SysML_SelectForm(title, modelNames, notifier);
		
		form.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE); // ~{^ĂȂ
		form.setBounds(xPos, yPos, width, height);
		form.setVisible(true);
		
		// [U̕ԓ|[Ođ҂
		long sleepTime = 100; // [ms]
		while(notifier.get_index() == SysML_SelectedItemNotifier.INDEX_NOT_DETERMINED){
			try{
				Thread.sleep(sleepTime);
			}
			catch(InterruptedException e){
				e.printStackTrace();
			}
		}
		
		// ISysMLfvf擾
		IRPModelElement selectedSysMLElm = null;
		int selectedIndex = notifier.get_index();
		if ( selectedIndex < 0 ){
			// IĂȂƂ͏I
			System.out.println("createLink : No SysML model element is selected.");
			return;
		}		
		selectedSysMLElm = models[selectedIndex];
		
		
		// ID-CasevfƂɃN𐶐
		IRPCollection col = app.getSelectedGraphElements();
		if ( col != null ){
			Iterator<?> itr = col.toList().iterator();
			while ( itr.hasNext() ) {
				IRPGraphElement gSrc = (IRPGraphElement) itr.next();
				IRPModelElement mSrc = gSrc.getModelObject();
				createEachLink(menuItem, gSrc, mSrc, selectedSysMLElm);
			}
		}
		else {
			System.out.println("createLink : No D-Case element is selected.");
		}
	}
	
	/**
	 * }EXőID-CasefvfƁAIʂőISysMLfvfɑ΂āAContextȂǂ̑ISysMLfvfǉ
	 * @param menuItem ǉSysMLfvf̎ʁiContextȂǁj
	 * @param gSrc ID-Casefvf̃OtGg
	 * @param mSrc ID-Casefvf̃fGg
	 * @param sysMLElm ISysMLfvf̃fGg
	 */
	private void createEachLink(String menuItem, IRPGraphElement gSrc, IRPModelElement mSrc, IRPModelElement sysMLElm) {
		
		IRPGraphNode gnSrc = null;
		// ID-Casefvfm[hł邱ƂmF
		if ( !(gSrc instanceof IRPGraphNode) ) {
			System.out.println("createEachLink : Edge is selected.");
			return;
		}
		gnSrc = (IRPGraphNode) gSrc;
		
		// ID-Casefvf̈ʒu擾
		int xSrcPosition = 0;
		int ySrcPosition = 0;
		
		String xySrcPosition = gnSrc.getGraphicalProperty("Position").getValue(); // . 300,200
		StringTokenizer st = new StringTokenizer(xySrcPosition, ",");
		if(st.hasMoreTokens()) {
			xSrcPosition = Integer.parseInt(st.nextToken());
		}
		if(st.hasMoreTokens()) {
			ySrcPosition = Integer.parseInt(st.nextToken());
		}
		
		// ID-Casefvf̃XeI^Cv擾
		String metaClass = getMetaClass(mSrc);
		
		// ǉ̃pbP[WDefaultƂ
		IRPPackage pkg = (IRPPackage) prj.findNestedElement("Default", "Package");
		
		// D-Casefvf擾
		DNode nSrc = new DNode(mSrc, metaClass);
		
		// ISysMLfvf̏擾
		String sysMLName = sysMLElm.getName();
		String sysMLDispName = sysMLElm.getDisplayName();
		
		// ǉD-Casefvf̈ʒuݒ肷
		int xTrgOffset = 200;
		int yTrgOffset = 0;
		int xTrgPosition = xSrcPosition + xTrgOffset;
		int yTrgPosition = ySrcPosition + yTrgOffset;
		int nodeWidth = 80;
		int nodeHeight = 60;
		
		// ޕʂD-Casefvfǉ
		DCaseDiagram d = new DCaseDiagram(app.getDiagramOfSelectedElement());
		int count =  prj.getNestedElementsRecursive().getCount(); // ʖ̖ɕt^AقȂ閼Ot^
		DNode nTrg = null;
		DEdge eTrg = null;
		String nodeElmName = sysMLName + "_" + count;
		
		// OɃ_uoCg܂ޏꍇ́AOӂ̃_IDɕύX
		if (nodeElmName.length() != nodeElmName.getBytes().length) {
			nodeElmName = UUID.randomUUID().toString().replaceAll("-", "") + "_" + count;
		}
		if ( menuItem.equals(DCasePlugin.MENU_LABEL_LINK_CONTEXT)){
			nTrg = new DContext(nodeElmName, sysMLDispName, prj, pkg);
			eTrg = new DInContextOf("InContextOf_" + count, "Link to " + sysMLName, prj, pkg, nSrc, nTrg);
		}
		else if ( menuItem.equals(DCasePlugin.MENU_LABEL_LINK_ASSUMPTION)){
			nTrg = new DAssumption(nodeElmName, sysMLDispName, prj, pkg);
			eTrg = new DInContextOf("InContextOf_" + count, "Link to " + sysMLName, prj, pkg, nSrc, nTrg);
		}
		else if ( menuItem.equals(DCasePlugin.MENU_LABEL_LINK_JUSTIFICATION)){
			nTrg = new DJustification(nodeElmName, sysMLDispName, prj, pkg);
			eTrg = new DInContextOf("InContextOf_" + count, "Link to " + sysMLName, prj, pkg, nSrc, nTrg);
		}
		else {
			System.out.println("createEachLink logical error : Unexpected type of menu item is selected.");
		}
		
		// nCp[Nǉ
		String linkName = "Link_" + count;
		String linkDispName = "LinkTo: " + sysMLElm.getDisplayName();
		nTrg.addHyperLink(linkName, linkDispName, sysMLElm);
		
		// D-Casefvf̃m[hƃGbW`悷
		IRPGraphNode gnTrg = d.addGraphNode(nTrg, xTrgPosition, yTrgPosition, nodeWidth, nodeHeight);
		IRPGraphEdge geTrg = d.addGraphEdge(eTrg, gnSrc, gnTrg);
	}
	
	/**
	 * ID-Casefvf̃XeI^Cv擾
	 * @param mSrc ID-Casefvf
	 * @return ID-Casefvf̃XeI^Cv
	 */
	private String getMetaClass(IRPModelElement mSrc) {
		String metaClass = "Goal";
		IRPCollection col = mSrc.getStereotypes();
		if ( col != null ){
			Iterator<?> itr = col.toList().iterator();
			while ( itr.hasNext() ) {
				IRPStereotype s = (IRPStereotype) itr.next();
				String sName = s.getName();
				
				if(sName.equals("Goal") || sName.equals("Strategy")){
					metaClass = sName;
				}
				else {
					System.err.println("Error getMetaClass : Type of selected model element is illegal (" + sName + ").");
				}
			}
		}
		else {
			System.out.println("getMetaClass : No stereotype is attached.");
		}
		return metaClass;
	}
	
	/**
	 * SysMLfvf̈ꗗ擾
	 * @return SysMLfvf̈ꗗ
	 */
	private IRPModelElement[] getModelElements() {
		ArrayList<IRPModelElement> modelList = new ArrayList<IRPModelElement>();
		
		IRPCollection col = prj.getNestedElementsRecursive();
		if ( col != null ){
			Iterator<?> itr = col.toList().iterator();
			while ( itr.hasNext() ) {
				IRPModelElement elm = (IRPModelElement) itr.next();
				String sIF = elm.getInterfaceName();
				// SysMLfvfɌ肷
				if(sIF.equals("IRPEnumerationLiteral")
						|| sIF.equals("IRPInstanceValue")
						|| sIF.equals("IRPLiteralSpecification")
						|| sIF.equals("IRPStereotype")
						|| sIF.equals("IRPTag")
						|| sIF.equals("IRPType")
						|| sIF.equals("IRPComponent")
						|| sIF.equals("IRPProject")
						|| sIF.equals("IRPPackage")
						|| sIF.equals("IRPComment")
						|| sIF.equals("IRPDependency")
						|| sIF.equals("IRPHyperLink")
						|| sIF.equals("IRPProfile")
						|| sIF.equals("IRPTableLayout")
						|| sIF.equals("IRPGeneralization")
						|| sIF.equals("IRPAttribute")
						|| sIF.equals("IRPConfiguration")
						|| sIF.equals("IRPFile")
						){
					// do nothing
				}
				else {
					// SysMLfvfXgɒǉ
					modelList.add(elm);
//					System.out.println(elm.getName() + "\t" + elm.getDisplayName());
				}
			}
		}
		IRPModelElement[] models = new IRPModelElement[modelList.size()];
		for(int i = 0; i < modelList.size(); i++){
			models[i] = modelList.get(i);
		}
		return models;
	}
	
	/**
	 * eXg
	 */
	public static void main(String[] args){
		IRPApplication app = null;
		try{
			app = RhapsodyAppServer.getActiveRhapsodyApplication();
		}
		catch(Exception e){
			System.out.println("Rhapsody is not active.");
			e.printStackTrace();
			System.exit(0);
		}
		IRPProject prj = app.activeProject();
		IRPPackage pkg = (IRPPackage) prj.findNestedElement("Default", "Package");
		if(pkg == null){
			pkg = prj.addPackage("Default");
		}
		
		String menuItem = DCasePlugin.MENU_LABEL_LINK_CONTEXT;
		SysML_LinkCreator creator = new SysML_LinkCreator(app);
		creator.createLink(menuItem);
	}
}
