/**
 * Copyright (c) IBM Japan 2013. All rights reserved.
 */
package net.dependableos.dcase.toolchain.rhapsodyextension.commands;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;

/**
 * SysMLfvf̈ꗗXg\NX
 */
public class SysML_SelectForm extends JFrame implements ActionListener {
	
	/** SysMLfvf̈ꗗXg */
	protected JList list;
	
	/** CfbNXǗ */
	protected SysML_SelectedItemNotifier notifier;
	
	
	/** OK{^̃x */
	private static final String BUTTON_LABEL_OK = "OK";
	
	/** CLOSE{^̃x */
	private static final String BUTTON_LABEL_CLOSE = "Close";
	
	/** OK{^̃ANVR}h */
	private static final String BUTTON_COMMAND_OK = "OK_BUTTON";
	
	/** CLOSE{^̃ANVR}h */
	private static final String BUTTON_COMMAND_CLOSE = "CLOSE_BUTTON";
	
	/** EBhẺ */
	public static final int WINDOW_WIDTH = 600;
	
	/** EBhȄc */
	public static final int WINDOW_HEIGHT = 400;
	
	/**
	 * RXgN^
	 * @param title EBhE^Cg
	 * @param data Xgꗗ
	 * @param notifier ICfbNXǗ notifier
	 */
	SysML_SelectForm(String title, String[] data, SysML_SelectedItemNotifier notifier){
		setTitle(title);
		
		this.list = new JList(data);
		this.notifier = notifier;
		
		list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION); // PI
		
		JScrollPane sp = new JScrollPane();
		sp.getViewport().setView(list);
		sp.setPreferredSize(new Dimension(WINDOW_WIDTH, WINDOW_HEIGHT));
		
		JPanel p = new JPanel();
		p.add(sp);
		
		JButton okButton = new JButton(BUTTON_LABEL_OK);
		okButton.addActionListener(this);
		okButton.setActionCommand(BUTTON_COMMAND_OK);
		
		JButton closeButton = new JButton(BUTTON_LABEL_CLOSE);
		closeButton.addActionListener(this);
		closeButton.setActionCommand(BUTTON_COMMAND_CLOSE);
		
		JPanel p2 = new JPanel();
		p2.add(okButton);
		p2.add(closeButton);

		getContentPane().add(p, BorderLayout.CENTER);
		getContentPane().add(p2, BorderLayout.SOUTH);
		
	}
	
	/**
	 * {^NbN̏
	 */
	public void actionPerformed(ActionEvent e){
		String actionCommand = e.getActionCommand();

		if (actionCommand.equals(BUTTON_COMMAND_OK)){
			int index = list.getSelectedIndex();
			this.notifier.set_index(index);
			dispose();
		}
		else if (actionCommand.equals(BUTTON_COMMAND_CLOSE)){
			String val = (String)list.getSelectedValue();
			if (val == null){
			}else{
			}
			this.notifier.set_index(SysML_SelectedItemNotifier.INDEX_NOT_SELECTED);
			dispose();
		}
		else{
			return;
		}
	}

	/**
	 * eXg
	 */
	public static void main(String[] args){
		String[] initData = {"vf1", "vf2"};
		String title = "EBhE";
		SysML_SelectedItemNotifier notifier = new SysML_SelectedItemNotifier();
		SysML_SelectForm test = new SysML_SelectForm(title, initData, notifier);
		test.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

		test.setBounds( 10, 10, WINDOW_WIDTH + 20, WINDOW_HEIGHT + 20);
		test.setVisible(true);
		
		long sleepTime = 100; // [ms]
		while(notifier.get_index() == SysML_SelectedItemNotifier.INDEX_NOT_DETERMINED){
			try{
				Thread.sleep(sleepTime);
			}
			catch(InterruptedException e){
				e.printStackTrace();
			}
		}
		
		System.out.println(notifier.get_index());
		System.out.println("End.");
	}

}
